-- Change to make aircurling eat Tails's remaining fly boosts
local CURLING_EATS_FLY = false

rawset(_G.krework.tails, "preFrame", function(player)
	local mo = player.mo
	
	-- Player 2 gets regular fly
	if player.bot
		player.charability = CA_FLY
	else
		-- Have to have flight or swimming to stay in tired flying state
		if not (mo.eflags & MFE_UNDERWATER)
			-- Swimming doesn't affect air flight physics, so go with that
			player.charability = CA_SWIM
		else
			-- Having swimming does affect swimming physics and we don't use tired flying underwater, so take it away underwater
			player.charability = CA_NONE
			-- Also infinite vertboost count when swimming
			mo.krework.tails.flycount = krework.tails.settings.BOOST_COUNT
		end
		
		player.krework.jumpused = not(max(mo.krework.tails.flycount, 0))
	end
end)

addHook("AbilitySpecial", A_KRTailsFly)

rawset(_G.krework.tails, "playerThink", function(player)
	if player.bot
		return
	end
	
	local mo = player.mo
	
	-- Eat all remaining fly boosts if you've aircurled
	if CURLING_EATS_FLY and mo.krework.tails.flytime > 0 and mo.krework.aircurled
		mo.krework.tails.flycount = 0
		return
	end
	
	-- If you're flying, run flying physics
	if (mo.state == S_PLAY_FLY
		or mo.state == S_PLAY_FLY_TIRED
		or mo.state == S_PLAY_SWIM)
		A_KRTailsHover(player)
	-- Otherwise, reset how long you've been flying
	else
		player.mo.krework.tails.flytime = 0
	end
end)
