hud.add(function(d, p, cam)
	if not krework.checkExistence(p)
	or not (p.mo.skin == "tails")
	or p.bot
	or CV_FindVar("powerupdisplay").value == 0 -- Never display powerup icons
	or (CV_FindVar("powerupdisplay").value == 1 and cam.chase) -- Only display in first-person and we're in third-person
	or not p.krework
	or not p.mo.krework
		return
	end
	
	-- Handle positioning for splitscreen
	local screenbottom = 200
	if splitscreen and p != secondarydisplayplayer
		screenbottom = 100
	end
	local flytime = p.mo.krework.tails.flytime
	
	-- Initialise HUD state vars
	p.krework.hud = $ or {}
	p.krework.hud.lastframe = $ or 0
	if p.krework.hud.lastchange == nil
	or leveltime < p.krework.hud.lastchange -- Restarts the hud timer on level change
		p.krework.hud.lastchange = 0
	end
	
	-- Pick an animation for the HUD icon
	local animation = "FLYICON"
	-- Falling animation if you've run out of flight
	if p.mo.krework.tails.flycount <= 0 and flytime == 0
		animation = "FALICON"
	end
	
	-- Decide how fast to play it
	local frametics = (flytime > 0 and flytime < krework.tails.settings.FLY_SPAMLOCK) and 1 -- Very fast during vertboost
						or ((flytime < krework.tails.settings.FLY_TIRED_TIME) and 2 -- Normal speed normally
						or 4) -- Slowly towards the end of a hover
	
	-- Advance the HUD icon's animation
	if leveltime >= (p.krework.hud.lastchange + frametics)
		p.krework.hud.lastframe = $+1
		p.krework.hud.lastchange = leveltime
	end
	
	-- Cycle back to frame 0 if we're at the end of an animation
	if not d.patchExists(animation .. tostring(p.krework.hud.lastframe))
		p.krework.hud.lastframe = 0
	end
	
	-- Actually draw the icon
	local flyicon = d.cachePatch(animation .. tostring(p.krework.hud.lastframe))
	d.drawScaled(304*FRACUNIT, (screenbottom - 8 - 16)*FRACUNIT, FRACUNIT/2, flyicon, 0, d.getColormap("tails", p.mo.color))
	
	-- Write how many fly boosts Tails has left on his icon
	d.drawString(320, screenbottom - 16, tostring(p.mo.krework.tails.flycount), 0, "thin-right")
end, "game")
